diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/lib/notifylog.c ./lib/notifylog.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/lib/notifylog.c	1970-01-01 01:00:00.000000000 +0100
+++ ./lib/notifylog.c	2007-02-09 11:06:31.266797268 +0100
@@ -0,0 +1,360 @@
+/*----------------------------------------------------------------------------*/
+/* Hobbit monitor library.                                                    */
+/*                                                                            */
+/* This displays the "notification" log.                                      */
+/*                                                                            */
+/* Copyright (C) 2002-2006 Henrik Storner <henrik@storner.dk>                 */
+/* Host/test/color/start/end filtering code by Eric Schwimmer 2005            */
+/*                                                                            */
+/* This program is released under the GNU General Public License (GPL),       */
+/* version 2. See the file "COPYING" for details.                             */
+/*                                                                            */
+/*----------------------------------------------------------------------------*/
+
+static char rcsid[] = "$Id: notifylog.c,v 1.2 2007/02/07 21:51:31 henrik Exp $";
+
+#include <limits.h>
+#include <stdio.h>
+#include <string.h>
+#include <stdlib.h>
+#include <ctype.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <dirent.h>
+#include <unistd.h>
+#include <fcntl.h>
+#include <errno.h>
+#include <time.h>
+
+#include <pcre.h>
+
+#include "libbbgen.h"
+
+typedef struct notification_t {
+	struct namelist_t *host;
+	struct htnames_t *service;
+	time_t  eventtime;
+	char *recipient;
+	struct notification_t *next;
+} notification_t;
+
+
+static time_t convert_time(char *timestamp)
+{
+	time_t event = 0;
+	unsigned int year,month,day,hour,min,sec,count;
+	struct tm timeinfo;
+
+	count = sscanf(timestamp, "%u/%u/%u@%u:%u:%u",
+		&year, &month, &day, &hour, &min, &sec);
+	if(count != 6) {
+		return -1;
+	}
+	if(year < 1970) {
+		return 0;
+	}
+	else {
+		memset(&timeinfo, 0, sizeof(timeinfo));
+		timeinfo.tm_year  = year - 1900;
+		timeinfo.tm_mon   = month - 1;
+		timeinfo.tm_mday  = day;
+		timeinfo.tm_hour  = hour;
+		timeinfo.tm_min   = min;
+		timeinfo.tm_sec   = sec;
+		timeinfo.tm_isdst = -1;
+		event = mktime(&timeinfo);		
+	}
+
+	return event;
+}
+
+static htnames_t *namehead = NULL;
+static htnames_t *getname(char *name, int createit)
+{
+	htnames_t *walk;
+
+	for (walk = namehead; (walk && strcmp(walk->name, name)); walk = walk->next) ;
+	if (walk || (!createit)) return walk;
+
+	walk = (htnames_t *)malloc(sizeof(htnames_t));
+	walk->name = strdup(name);
+	walk->next = namehead;
+	namehead = walk;
+
+	return walk;
+}
+
+void do_notifylog(FILE *output, 
+		  int maxcount, int maxminutes, char *fromtime, char *totime, 
+		  char *pageregex, char *expageregex,
+		  char *hostregex, char *exhostregex,
+		  char *testregex, char *extestregex,
+		  char *rcptregex, char *exrcptregex)
+{
+	FILE *notifylog;
+	char notifylogfilename[PATH_MAX];
+	time_t firstevent = 0;
+	time_t lastevent = time(NULL);
+	notification_t *head, *walk;
+	struct stat st;
+	char l[MAX_LINE_LEN];
+	char title[200];
+
+	/* For the PCRE matching */
+	const char *errmsg = NULL;
+	int errofs = 0;
+	pcre *pageregexp = NULL;
+	pcre *expageregexp = NULL;
+	pcre *hostregexp = NULL;
+	pcre *exhostregexp = NULL;
+	pcre *testregexp = NULL;
+	pcre *extestregexp = NULL;
+	pcre *rcptregexp = NULL;
+	pcre *exrcptregexp = NULL;
+
+	if (maxminutes && (fromtime || totime)) {
+		fprintf(output, "<B>Only one time interval type is allowed!</B>");
+		return;
+	}
+
+	if (fromtime) {
+		firstevent = convert_time(fromtime);
+		if(firstevent < 0) {
+			fprintf(output,"<B>Invalid 'from' time: %s</B>", fromtime);
+			return;
+		}
+	}
+	else if (maxminutes) {
+		firstevent = time(NULL) - maxminutes*60;
+	}
+	else {
+		firstevent = time(NULL) - 86400;
+	}
+
+	if (totime) {
+		lastevent = convert_time(totime);
+		if (lastevent < 0) {
+			fprintf(output,"<B>Invalid 'to' time: %s</B>", totime);
+			return;
+		}
+		if (lastevent < firstevent) {
+			fprintf(output,"<B>'to' time must be after 'from' time.</B>");
+			return;
+		}
+	}
+
+	if (!maxcount) maxcount = 100;
+
+	if (pageregex && *pageregex) pageregexp = pcre_compile(pageregex, PCRE_CASELESS, &errmsg, &errofs, NULL);
+	if (expageregex && *expageregex) expageregexp = pcre_compile(expageregex, PCRE_CASELESS, &errmsg, &errofs, NULL);
+	if (hostregex && *hostregex) hostregexp = pcre_compile(hostregex, PCRE_CASELESS, &errmsg, &errofs, NULL);
+	if (exhostregex && *exhostregex) exhostregexp = pcre_compile(exhostregex, PCRE_CASELESS, &errmsg, &errofs, NULL);
+	if (testregex && *testregex) testregexp = pcre_compile(testregex, PCRE_CASELESS, &errmsg, &errofs, NULL);
+	if (extestregex && *extestregex) extestregexp = pcre_compile(extestregex, PCRE_CASELESS, &errmsg, &errofs, NULL);
+	if (rcptregex && *rcptregex) rcptregexp = pcre_compile(rcptregex, PCRE_CASELESS, &errmsg, &errofs, NULL);
+	if (exrcptregex && *exrcptregex) exrcptregexp = pcre_compile(exrcptregex, PCRE_CASELESS, &errmsg, &errofs, NULL);
+
+	sprintf(notifylogfilename, "%s/notifications.log", xgetenv("BBSERVERLOGS"));
+	notifylog = fopen(notifylogfilename, "r");
+
+	if (notifylog && (stat(notifylogfilename, &st) == 0)) {
+		time_t curtime;
+		int done = 0;
+
+		/* Find a spot in the notification log file close to where the firstevent time is */
+		fseeko(notifylog, 0, SEEK_END);
+		do {
+			/* Go back maxcount*80 bytes - one entry is ~80 bytes */
+			if (ftello(notifylog) > maxcount*80) {
+				unsigned int uicurtime;
+				fseeko(notifylog, -maxcount*80, SEEK_CUR); 
+				fgets(l, sizeof(l), notifylog); /* Skip to start of line */
+				fgets(l, sizeof(l), notifylog);
+				/* Sun Jan  7 10:29:08 2007 myhost.disk (130.225.226.90) foo@test.com 1168162147 100 */
+				sscanf(l, "%*s %*s %*u %*u:%*u:%*u %*u %*s %*s %*s %u %*d", &uicurtime);
+				curtime = uicurtime;
+				done = (curtime < firstevent);
+			}
+			else {
+				rewind(notifylog);
+				done = 1;
+			}
+		} while (!done);
+	}
+	
+	head = NULL;
+
+	while (notifylog && (fgets(l, sizeof(l), notifylog))) {
+
+		time_t eventtime;
+		char hostsvc[MAX_LINE_LEN];
+		char recipient[MAX_LINE_LEN];
+		char *hostname, *svcname, *p;
+		int itemsfound, pagematch, hostmatch, testmatch, rcptmatch;
+		notification_t *newrec;
+		struct namelist_t *eventhost;
+		struct htnames_t *eventcolumn;
+		int ovector[30];
+
+		itemsfound = sscanf(l, "%*s %*s %*u %*u:%*u:%*u %*u %s %*s %s %u %*d", hostsvc, recipient, &eventtime);
+		if (itemsfound != 3) continue;
+		if (eventtime < firstevent) continue;
+		if (eventtime > lastevent) break;
+
+		hostname = hostsvc; svcname = strrchr(hostsvc, '.'); if (svcname) { *svcname = '\0'; svcname++; } else svcname = "";
+		eventhost = hostinfo(hostname);
+		if (!eventhost) continue; /* Dont report hosts that no longer exist */
+		eventcolumn = getname(svcname, 1);
+
+		p = strchr(recipient, '['); if (p) *p = '\0';
+
+		if (pageregexp) {
+			char *pagename = bbh_item(eventhost, BBH_PAGEPATH);
+			pagematch = (pcre_exec(pageregexp, NULL, pagename, strlen(pagename), 0, 0, 
+					ovector, (sizeof(ovector)/sizeof(int))) >= 0);
+		}
+		else
+			pagematch = 1;
+		if (!pagematch) continue;
+
+		if (expageregexp) {
+			char *pagename = bbh_item(eventhost, BBH_PAGEPATH);
+			pagematch = (pcre_exec(expageregexp, NULL, pagename, strlen(pagename), 0, 0, 
+					ovector, (sizeof(ovector)/sizeof(int))) >= 0);
+		}
+		else
+			pagematch = 0;
+		if (pagematch) continue;
+
+		if (hostregexp)
+			hostmatch = (pcre_exec(hostregexp, NULL, hostname, strlen(hostname), 0, 0, 
+					ovector, (sizeof(ovector)/sizeof(int))) >= 0);
+		else
+			hostmatch = 1;
+		if (!hostmatch) continue;
+
+		if (exhostregexp)
+			hostmatch = (pcre_exec(exhostregexp, NULL, hostname, strlen(hostname), 0, 0, 
+					ovector, (sizeof(ovector)/sizeof(int))) >= 0);
+		else
+			hostmatch = 0;
+		if (hostmatch) continue;
+
+		if (testregexp)
+			testmatch = (pcre_exec(testregexp, NULL, svcname, strlen(svcname), 0, 0, 
+					ovector, (sizeof(ovector)/sizeof(int))) >= 0);
+		else
+			testmatch = 1;
+		if (!testmatch) continue;
+
+		if (extestregexp)
+			testmatch = (pcre_exec(extestregexp, NULL, svcname, strlen(svcname), 0, 0, 
+					ovector, (sizeof(ovector)/sizeof(int))) >= 0);
+		else
+			testmatch = 0;
+		if (testmatch) continue;
+
+		if (rcptregexp)
+			rcptmatch = (pcre_exec(rcptregexp, NULL, recipient, strlen(recipient), 0, 0, 
+					ovector, (sizeof(ovector)/sizeof(int))) >= 0);
+		else
+			rcptmatch = 1;
+		if (!rcptmatch) continue;
+
+		if (exrcptregexp)
+			rcptmatch = (pcre_exec(exrcptregexp, NULL, recipient, strlen(recipient), 0, 0, 
+					ovector, (sizeof(ovector)/sizeof(int))) >= 0);
+		else
+			rcptmatch = 0;
+		if (rcptmatch) continue;
+
+		newrec = (notification_t *) malloc(sizeof(notification_t));
+		newrec->host       = eventhost;
+		newrec->service    = eventcolumn;
+		newrec->eventtime  = eventtime;
+		newrec->recipient  = strdup(recipient);
+		newrec->next       = head;
+		head = newrec;
+	}
+
+	if (head) {
+		char *bgcolors[2] = { "#000000", "#000066" };
+		int  bgcolor = 0;
+		int  count;
+		struct notification_t *lasttoshow = head;
+
+		count=0;
+		walk=head; 
+		do {
+			count++;
+			lasttoshow = walk;
+			walk = walk->next;
+		} while (walk && (count<maxcount));
+
+		if (maxminutes)  { 
+			sprintf(title, "%d notifications in the past %u minutes", 
+				count, (unsigned int)((time(NULL) - lasttoshow->eventtime) / 60));
+		}
+		else {
+			sprintf(title, "%d notifications sent.", count);
+		}
+
+		fprintf(output, "<BR><BR>\n");
+		fprintf(output, "<TABLE SUMMARY=\"Notification log\" BORDER=0>\n");
+		fprintf(output, "<TR BGCOLOR=\"#333333\">\n");
+		fprintf(output, "<TD ALIGN=CENTER COLSPAN=4><FONT SIZE=-1 COLOR=\"#33ebf4\">%s</FONT></TD></TR>\n", title);
+		fprintf(output, "<TR BGCOLOR=\"#333333\"><TH>Time</TH><TH>Host</TH><TH>Service</TH><TH>Recipient</TH></TR>\n");
+
+		for (walk=head; (walk != lasttoshow->next); walk=walk->next) {
+			char *hostname = bbh_item(walk->host, BBH_HOSTNAME);
+
+			fprintf(output, "<TR BGCOLOR=%s>\n", bgcolors[bgcolor]);
+			bgcolor = ((bgcolor + 1) % 2);
+
+			fprintf(output, "<TD ALIGN=LEFT>%s</TD>\n", ctime(&walk->eventtime));
+
+			fprintf(output, "<TD ALIGN=LEFT>%s</TD>\n", hostname);
+			fprintf(output, "<TD ALIGN=LEFT>%s</TD>\n", walk->service->name);
+			fprintf(output, "<TD ALIGN=LEFT>%s</TD>\n", walk->recipient);
+		}
+
+		fprintf(output, "</TABLE>\n");
+
+		/* Clean up */
+		walk = head;
+		do {
+			struct notification_t *tmp = walk;
+
+			walk = walk->next;
+			xfree(tmp->recipient);
+			xfree(tmp);
+		} while (walk);
+	}
+	else {
+		/* No notifications during the past maxminutes */
+		if (notifylog)
+			sprintf(title, "No notifications sent in the last %d minutes", maxminutes);
+		else
+			strcpy(title, "No notifications logged");
+
+		fprintf(output, "<CENTER><BR>\n");
+		fprintf(output, "<TABLE SUMMARY=\"%s\" BORDER=0>\n", title);
+		fprintf(output, "<TR BGCOLOR=\"#333333\">\n");
+		fprintf(output, "<TD ALIGN=CENTER COLSPAN=6><FONT SIZE=-1 COLOR=\"#33ebf4\">%s</FONT></TD>\n", title);
+		fprintf(output, "</TR>\n");
+		fprintf(output, "</TABLE>\n");
+		fprintf(output, "</CENTER>\n");
+	}
+
+	if (notifylog) fclose(notifylog);
+
+	if (pageregexp)   pcre_free(pageregexp);
+	if (expageregexp) pcre_free(expageregexp);
+	if (hostregexp)   pcre_free(hostregexp);
+	if (exhostregexp) pcre_free(exhostregexp);
+	if (testregexp)   pcre_free(testregexp);
+	if (extestregexp) pcre_free(extestregexp);
+	if (rcptregexp)   pcre_free(rcptregexp);
+	if (exrcptregexp) pcre_free(exrcptregexp);
+}
+
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/lib/notifylog.h ./lib/notifylog.h
--- /home/henrik/hobbit/release/hobbit-4.2.0/lib/notifylog.h	1970-01-01 01:00:00.000000000 +0100
+++ ./lib/notifylog.h	2007-02-09 11:06:31.269796723 +0100
@@ -0,0 +1,21 @@
+/*----------------------------------------------------------------------------*/
+/* Hobbit monitor library.                                                    */
+/*                                                                            */
+/* Copyright (C) 2002-2006 Henrik Storner <henrik@storner.dk>                 */
+/*                                                                            */
+/* This program is released under the GNU General Public License (GPL),       */
+/* version 2. See the file "COPYING" for details.                             */
+/*                                                                            */
+/*----------------------------------------------------------------------------*/
+
+#ifndef __NOTIFYLOG_H_
+#define __NOTIFYLOG_H_
+
+extern void do_notifylog(FILE *output, int maxcount, int maxminutes, char *fromtime, char *totime, 
+			 char *pagematch, char *expagematch, 
+			 char *hostmatch, char *exhostmatch, 
+			 char *testmatch, char *extestmatch,
+			 char *rcptmatch, char *exrcptmatch);
+
+#endif
+
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/lib/timefunc.c ./lib/timefunc.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/lib/timefunc.c	2006-08-09 22:10:16.000000000 +0200
+++ ./lib/timefunc.c	2006-10-03 13:52:29.000000000 +0200
@@ -245,6 +245,7 @@
 	return found;
 }
 
+#ifndef CLIENTONLY
 char *check_downtime(char *hostname, char *testname)
 {
 	namelist_t *hinfo = hostinfo(hostname);
@@ -300,6 +301,7 @@
 
 	return NULL;
 }
+#endif
 
 int periodcoversnow(char *tag)
 {
@@ -415,20 +417,30 @@
 	 */
 
 	int result = 0;
-	char *p;
-	char modifier;
+	char *startofval;
 
-	p = dur + strspn(dur, "0123456789");
-	modifier = *p;
-	*p = '\0';
-	result = atoi(dur);
-	*p = modifier;
+	startofval = dur;
+
+	while (startofval && (isdigit((int)*startofval))) {
+		char *p;
+		char modifier;
+		int oneval = 0;
+
+		p = startofval + strspn(startofval, "0123456789");
+		modifier = *p;
+		*p = '\0';
+		oneval = atoi(startofval);
+		*p = modifier;
+
+		switch (modifier) {
+		  case 'm': break;			/* minutes */
+		  case 'h': oneval *= 60; break;	/* hours */
+		  case 'd': oneval *= 1440; break;	/* days */
+		  case 'w': oneval *= 10080; break;	/* weeks */
+		}
 
-	switch (modifier) {
-	  case 'm': break;			/* minutes */
-	  case 'h': result *= 60; break;	/* hours */
-	  case 'd': result *= 1440; break;	/* days */
-	  case 'w': result *= 10080; break;	/* weeks */
+		result += oneval;
+		startofval = ((*p) ? p+1 : NULL);
 	}
 
 	return result;
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/web/Makefile ./web/Makefile
--- /home/henrik/hobbit/release/hobbit-4.2.0/web/Makefile	2006-08-09 22:10:13.000000000 +0200
+++ ./web/Makefile	2007-02-09 11:06:18.666086326 +0100
@@ -1,5 +1,5 @@
-PROGRAMS = bb-hist.cgi bb-eventlog.cgi bb-rep.cgi bb-replog.cgi bb-snapshot.cgi bb-findhost.cgi bb-csvinfo.cgi bb-ack.cgi bb-webpage bb-datepage.cgi hobbitgraph.cgi hobbitsvc.cgi hobbit-enadis.cgi hobbit-confreport.cgi hobbit-nkview.cgi hobbit-nkedit.cgi hobbit-ackinfo.cgi hobbit-statusreport.cgi boilerplate.cgi hobbit-hostgraphs.cgi hobbit-ghosts.cgi
-CGISCRIPTS = bb-hist.sh bb-eventlog.sh bb-rep.sh bb-replog.sh bb-snapshot.sh bb-findhost.sh bb-csvinfo.sh hobbitcolumn.sh bb-datepage.sh hobbitgraph.sh bb-hostsvc.sh bb-histlog.sh hobbit-confreport.sh hobbit-nkview.sh hobbit-certreport.sh hobbit-nongreen.sh hobbit-hostgraphs.sh hobbit-ghosts.sh
+PROGRAMS = bb-hist.cgi bb-eventlog.cgi bb-rep.cgi bb-replog.cgi bb-snapshot.cgi bb-findhost.cgi bb-csvinfo.cgi bb-ack.cgi bb-webpage bb-datepage.cgi hobbitgraph.cgi hobbitsvc.cgi hobbit-enadis.cgi hobbit-confreport.cgi hobbit-nkview.cgi hobbit-nkedit.cgi hobbit-ackinfo.cgi hobbit-statusreport.cgi boilerplate.cgi hobbit-hostgraphs.cgi hobbit-ghosts.cgi hobbit-notifylog.cgi
+CGISCRIPTS = bb-hist.sh bb-eventlog.sh bb-rep.sh bb-replog.sh bb-snapshot.sh bb-findhost.sh bb-csvinfo.sh hobbitcolumn.sh bb-datepage.sh hobbitgraph.sh bb-hostsvc.sh bb-histlog.sh hobbit-confreport.sh hobbit-confreport-critical.sh hobbit-nkview.sh hobbit-certreport.sh hobbit-nongreen.sh hobbit-hostgraphs.sh hobbit-ghosts.sh hobbit-notifylog.sh
 SECCGISCRIPTS = bb-ack.sh hobbit-enadis.sh hobbit-nkedit.sh hobbit-ackinfo.sh
 
 LIBOBJS = ../lib/libbbgen.a
@@ -25,6 +25,7 @@
 STATUSREPOBJS   = hobbit-statusreport.o
 MAILACKOBJS     = hobbit-mailack.o
 GHOSTOBJS       = hobbit-ghosts.o
+NOTIFYOBJS      = hobbit-notifylog.o
 
 HOSTGRAPHSOBJS  = hobbit-hostgraphs.o
 BOILERPLATEOBJS = boilerplate.o
@@ -105,6 +106,9 @@
 hobbit-ghosts.cgi: $(GHOSTOBJS) $(LIBOBJS)
 	$(CC) $(CFLAGS) -o $@ $(RPATHOPT) $(GHOSTOBJS) $(LIBOBJS) $(PCRELIBS) $(NETLIBS)
 
+hobbit-notifylog.cgi: $(NOTIFYOBJS) $(LIBOBJS)
+	$(CC) $(CFLAGS) -o $@ $(RPATHOPT) $(NOTIFYOBJS) $(LIBOBJS) $(PCRELIBS) $(NETLIBS)
+
 
 bb-ack.sh: bb-ack.sh.DIST
 	cat $< | sed -e 's!@BBHOME@!$(BBHOME)!g' | sed -e 's!@RUNTIMEDEFS@!$(RUNTIMEDEFS)!g' >$@
@@ -178,6 +182,10 @@
 	cat $< | sed -e 's!@BBHOME@!$(BBHOME)!g' | sed -e 's!@RUNTIMEDEFS@!$(RUNTIMEDEFS)!g' >$@
 	chmod 755 $@
 
+hobbit-confreport-critical.sh: hobbit-confreport-critical.sh.DIST
+	cat $< | sed -e 's!@BBHOME@!$(BBHOME)!g' | sed -e 's!@RUNTIMEDEFS@!$(RUNTIMEDEFS)!g' >$@
+	chmod 755 $@
+
 hobbit-certreport.sh: hobbit-certreport.sh.DIST
 	cat $< | sed -e 's!@BBHOME@!$(BBHOME)!g' | sed -e 's!@RUNTIMEDEFS@!$(RUNTIMEDEFS)!g' >$@
 	chmod 755 $@
@@ -194,6 +202,10 @@
 	cat $< | sed -e 's!@BBHOME@!$(BBHOME)!g' | sed -e 's!@RUNTIMEDEFS@!$(RUNTIMEDEFS)!g' >$@
 	chmod 755 $@
 
+hobbit-notifylog.sh: hobbit-notifylog.sh.DIST
+	cat $< | sed -e 's!@BBHOME@!$(BBHOME)!g' | sed -e 's!@RUNTIMEDEFS@!$(RUNTIMEDEFS)!g' >$@
+	chmod 755 $@
+
 
 %.o: %.c
 	$(CC) $(CFLAGS) -c -o $@ $<
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/web/bb-ack.c ./web/bb-ack.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/web/bb-ack.c	2006-08-09 22:10:12.000000000 +0200
+++ ./web/bb-ack.c	2006-10-03 13:52:29.000000000 +0200
@@ -133,7 +133,7 @@
 				}
 
 				if (acknum) awalk->acknum = atoi(acknum);
-				if (validity) awalk->validity = atoi(validity);
+				if (validity) awalk->validity = durationvalue(validity);
 				if (ackmsg) awalk->ackmsg = strdup(ackmsg);
 				if (hostname) awalk->hostname = strdup(hostname);
 				if (testname) awalk->testname = strdup(testname);
@@ -161,7 +161,7 @@
 
 	fprintf(output, "    <td>%s</td>\n", (hname ? hname : "&nbsp;"));
 	fprintf(output, "    <td>%s</td>\n", (tname ? tname : "&nbsp;"));
-	fprintf(output, "    <TD><INPUT TYPE=TEXT NAME=\"DELAY_%s\" SIZE=4 MAXLENGTH=4></TD>\n", numstr);
+	fprintf(output, "    <TD><INPUT TYPE=TEXT NAME=\"DELAY_%s\" SIZE=8 MAXLENGTH=20></TD>\n", numstr);
 	fprintf(output, "    <TD><INPUT TYPE=TEXT NAME=\"MESSAGE_%s\" SIZE=60 MAXLENGTH=80></TD>\n", numstr);
 
 	fprintf(output, "    <TD>\n");
@@ -224,42 +224,31 @@
 				 NULL, NULL);
 		}
 		else {
-			char cmd[1024];
+			char *cmd;
 			char *respbuf = NULL;
-                	char *cookie = NULL, *p;
+			char *hostname, *pagename;
 			int gotfilter = 0;
 
 			headfoot(stdout, "acknowledge", "", "header", COL_RED);
 
+			cmd = (char *)malloc(1024);
 			strcpy(cmd, "hobbitdboard color=red,yellow fields=hostname,testname,cookie");
 
-			p = getenv("HTTP_COOKIE"); 
-			if (p) cookie = strdup(p);
-
-			if (obeycookies && cookie && ((p = strstr(cookie, "host=")) != NULL)) {
-				char *hostname;
-				
-				hostname = p + strlen("host=");
-				p = strchr(hostname, ';'); if (p) *p = '\0';
+			if (obeycookies && !gotfilter && ((hostname = get_cookie("host")) != NULL)) {
 				if (*hostname) {
-					sprintf(cmd + strlen(cmd), " host=%s", hostname);
+					cmd = (char *)realloc(cmd, 1024 + strlen(hostname));
+					sprintf(cmd + strlen(cmd), " host=^%s$", hostname);
 					gotfilter = 1;
 				}
-				if (p) *p = ';';
 			}
 
-			if (obeycookies && cookie && !gotfilter && ((p = strstr(cookie, "pagepath=")) != NULL)) {
-				char *pagename;
-
-				pagename = p + strlen("pagepath=");
-				p = strchr(pagename, ';'); if (p) *p = '\0';
+			if (obeycookies && !gotfilter && ((pagename = get_cookie("pagepath")) != NULL)) {
 				if (*pagename) {
-					sprintf(cmd + strlen(cmd), " page=^%s$", pagename);
+					cmd = (char *)realloc(cmd, 1024 + 2*strlen(pagename));
+					sprintf(cmd + strlen(cmd), " page=^%s$|^%s/.+", pagename, pagename);
 					gotfilter = 1;
 				}
-				if (p) *p = ';';
 			}
-			xfree(cookie);
 
 			if (sendmessage(cmd, NULL, NULL, &respbuf, 1, BBTALK_TIMEOUT) == BB_OK) {
 				char *bol, *eoln;
@@ -327,7 +316,7 @@
 
 			if (reqtype == ACK_MANY) {
 				if (!awalk->ackmsg) awalk->ackmsg = ackmsgall;
-				if (!awalk->validity && validityall) awalk->validity = atoi(validityall);
+				if (!awalk->validity && validityall) awalk->validity = durationvalue(validityall);
 			}
 
 			count++;
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/web/bb-datepage.c ./web/bb-datepage.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/web/bb-datepage.c	2006-08-09 22:10:12.000000000 +0200
+++ ./web/bb-datepage.c	2006-10-03 12:55:27.000000000 +0200
@@ -108,30 +108,21 @@
 	parse_query();
 
 	if (cgi_method == CGI_POST) {
-		char *cookie, *pagepath, *p;
-		char *endurl;
+		char *pagepath, *cookie, *endurl;
 
-		cookie = getenv("HTTP_COOKIE");
-		if (cookie == NULL) {
-			errormsg("Cookies must be enabled\n");
-			return 1;
+		cookie = get_cookie("pagepath");
+
+		if (cookie && *cookie) {
+			pagepath = strdup(cookie);
 		}
+		else {
+			cookie = get_cookie("host");
 
-		p = strstr(cookie, "pagepath="); if (p) p+= strlen("pagepath=");
-		if ((p == NULL) || (strlen(p) == 0) || (*p == ';')) {
-			p = strstr(cookie, "host="); if (p) p += strlen("host=");
-			if ((p == NULL) || (strlen(p) == 0) || (*p == ';')) {
-				pagepath = "";
-			}
-			else {
-				char *hname;
+			if (cookie && *cookie) {
 				namelist_t *hinfo;
 
-				hname = strdup(p);
-				p = strchr(hname, ';'); if (p) *p = '\0';
-
 				load_hostnames(xgetenv("BBHOSTS"), NULL, get_fqdn());
-				hinfo = hostinfo(hname);
+				hinfo = hostinfo(cookie);
 				if (hinfo) {
 					pagepath = bbh_item(hinfo, BBH_PAGEPATH);
 				}
@@ -139,10 +130,9 @@
 					pagepath = "";
 				}
 			}
-		}
-		else {
-			pagepath = strdup(p);
-			p = strchr(pagepath, ';'); if (p) *p = '\0';
+			else {
+				pagepath = "";
+			}
 		}
 
 		endurl = (char *)malloc(strlen(urlprefix) + strlen(pagepath) + 1024);
@@ -201,6 +191,7 @@
 		}
 
 		sethostenv("", "", "", colorname(bgcolor), NULL);
+		fprintf(stdout, "Content-type: %s\n\n", xgetenv("HTMLCONTENTTYPE"));
 		showform(stdout, hffile, formfn, COL_BLUE, seltime, NULL, NULL);
 	}
 
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/web/bb-eventlog.c ./web/bb-eventlog.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/web/bb-eventlog.c	2006-08-09 22:10:12.000000000 +0200
+++ ./web/bb-eventlog.c	2006-10-03 12:55:27.000000000 +0200
@@ -114,6 +114,8 @@
 
 	redirect_cgilog("bb-eventlog");
 
+	fprintf(stdout, "Content-type: %s\n\n", xgetenv("HTMLCONTENTTYPE"));
+
 	cgidata = cgi_request();
 	if (cgidata == NULL) {
 		/* Present the query form */
@@ -126,8 +128,6 @@
 	load_hostnames(xgetenv("BBHOSTS"), NULL, get_fqdn());
 
 	/* Now generate the webpage */
-	printf("Content-Type: %s\n\n", xgetenv("HTMLCONTENTTYPE"));
-
 	headfoot(stdout, "event", "", "header", COL_GREEN);
 	fprintf(stdout, "<center>\n");
 	do_eventlog(stdout, maxcount, maxminutes, fromtime, totime, 
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/web/bb-findhost.c ./web/bb-findhost.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/web/bb-findhost.c	2006-08-09 22:10:12.000000000 +0200
+++ ./web/bb-findhost.c	2006-10-03 12:55:27.000000000 +0200
@@ -152,6 +152,7 @@
 	if (cgidata == NULL) {
 		/* Present the query form */
 		sethostenv("", "", "", colorname(COL_BLUE), NULL);
+		printf("Content-type: %s\n\n", xgetenv("HTMLCONTENTTYPE"));
 		showform(stdout, "findhost", "findhost_form", COL_BLUE, getcurrenttime(NULL), NULL, NULL);
 		return 0;
 	}
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/web/bb-rep.c ./web/bb-rep.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/web/bb-rep.c	2006-08-09 22:10:12.000000000 +0200
+++ ./web/bb-rep.c	2006-10-03 12:55:27.000000000 +0200
@@ -230,6 +230,7 @@
 	if (cgidata == NULL) {
 		/* Present the query form */
 		sethostenv("", "", "", colorname(COL_BLUE), NULL);
+		printf("Content-type: %s\n\n", xgetenv("HTMLCONTENTTYPE"));
 		showform(stdout, "report", "report_form", COL_BLUE, getcurrenttime(NULL)-86400, NULL, NULL);
 		return 0;
 	}
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/web/bb-snapshot.c ./web/bb-snapshot.c
--- /home/henrik/hobbit/release/hobbit-4.2.0/web/bb-snapshot.c	2006-08-09 22:10:12.000000000 +0200
+++ ./web/bb-snapshot.c	2006-10-03 12:55:27.000000000 +0200
@@ -173,6 +173,7 @@
 	if (cgidata == NULL) {
 		/* Present the query form */
 		sethostenv("", "", "", colorname(COL_BLUE), NULL);
+		printf("Content-type: %s\n\n", xgetenv("HTMLCONTENTTYPE"));
 		showform(stdout, "snapshot", "snapshot_form", COL_BLUE, getcurrenttime(NULL), NULL, NULL);
 		return 0;
 	}
diff -urN /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbit-confreport-critical.sh.DIST ./web/hobbit-confreport-critical.sh.DIST
--- /home/henrik/hobbit/release/hobbit-4.2.0/web/hobbit-confreport-critical.sh.DIST	1970-01-01 01:00:00.000000000 +0100
+++ ./web/hobbit-confreport-critical.sh.DIST	2006-10-03 12:55:27.000000000 +0200
@@ -0,0 +1,10 @@
+#!/bin/sh
+
+# This is the Hobbit CGI script interface to hobbit-confreport.cgi
+# It shows only the statuses on the Critical systems view
+#
+# Install this script in your webservers' cgi-bin directory
+
+. @BBHOME@/etc/hobbitcgi.cfg
+@RUNTIMEDEFS@ exec @BBHOME@/bin/hobbit-confreport.cgi $CGI_HOBBITCONFREPORT_OPTS --critical
+
